/* *******************
 * preferences.js
 * a slightly modified version of preferences.js
 * from  QuickNote  <http://quicknote.mozdev.org/>
 *
 ******************** */
 
 
// the base function that returns your preferences object
 function getDeskcutPrefs() {
  return deskcutPrefs;
}

// our preferences object
var deskcutPrefs = {
  gPreferences: null,
  // a fxn to return your branch of userprefs
  getPreferences: function() {
    if(!this.gPreferences) {
      try {
        this.gPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                            getService(Components.interfaces.nsIPrefService).
                            getBranch("deskcut.");
                            // replace the above deskcut with your extension name
      } catch (e) {}
    }
    return this.gPreferences;
  },
  // now define your variable types
  types: {
    // use name: #
    // where name is the name of your var and # is 0 for bools, 1 for ints, 2 for chars and 3 for unichars
    /*bool*/  alert_messagebox: 0, alert_audio: 0, alert_beep: 0, alert_wav: 0, add_date: 0, make_unique: 0,
    /*int*/   file_overwrite: 1, name_scheme: 1, dir_scheme: 1, dup_format: 1,
    /*char*/  desk_path: 2 , date_format: 2 ,wav_path: 2,
    /*unichar*/ // foobar:3,
  },
  // assign some default values for your prefs
  defaults: {
    alert_messagebox: false, alert_audio: false, alert_beep: false, alert_wav: false, add_date: false, make_unique: false,
    file_overwrite: 0, name_scheme: 1, dir_scheme: 2, dup_format: 0,
    desk_path: "" , date_format: "YYYYMMDD" ,wav_path: "", 
  } ,
  // get function
  // var alert_messagebox = MyExtensionPrefs.get("alert_messagebox");
  get: function(aPrefName) {
    try {
      var pref = this.getPreferences();
      switch(this.types[aPrefName]) {
        case 0:
          return pref.getBoolPref(aPrefName);
        case 1:
          return pref.getIntPref(aPrefName);
        case 2:
          return pref.getCharPref(aPrefName);
        case 3:
          return pref.getComplexValue(aPrefName,
            Components.interfaces.nsIPrefLocalizedString).data;
      }
    } catch(e) {}
    return this.defaults[aPrefName];
  },
  // set function
  // MyExtensionPrefs.set (alert_messagebox, true)
  set: function(aPrefName, aValue) {
      var pref = this.getPreferences();
      switch(this.types[aPrefName]) {
        case 0:
          pref.setBoolPref(aPrefName, aValue);
          break;
        case 1:
          pref.setIntPref(aPrefName, aValue);
          break;
        case 2:
          pref.setCharPref(aPrefName, aValue);
          break;
        case 3:
          var str = Components.classes["@mozilla.org/supports-string;1"]
                      .createInstance(Components.interfaces.nsISupportsString);
          str.data = aValue;
          pref.setComplexValue(aPrefName,
                                 Components.interfaces.nsISupportsString, str);
          break;
      }
  },
  // clear fxn
  clear: function(aPrefName) {
    this.getPreferences().clearUserPref(aPrefName);
  }
};
